// ----------------------------------------------------------------------------
// Projekt       : Analytica AnaGate Lua-API
// File          : LuaCANFunctions.h
// Author        : Stefan Welisch
// Copyright     : (C) 2009 by Analytica GmbH
// ----------------------------------------------------------------------------
// $Id:$
//
// $Log:$
//
// ----------------------------------------------------------------------------

// Includes -------------------------------------------------------------------
/// Includes for Scripting
extern "C"
{
   #include "lua.h"
   #include "lauxlib.h"
   #include "lualib.h"

   extern lua_State * L;
}

#include <AnaGateDllCan.h>  // windows.h must be included before ...


namespace lua {
void RegisterCANFunctions( lua_State * L );
};

void WINAPI MyCallbackEx(int nIdentifier, const char * pcBuffer, int nBufferLen, int nFlags, int hHandle, long nSeconds, long nMicroseconds);
void StandardCallback(int nIdentifier, const char * pcBuffer, int nBufferLen, int nFlags, int hHandle, long nSeconds, long nMicroseconds);

/// LUA-Interface
int LS_CANOpenDevice( lua_State * L );
int LS_CANCloseDevice( lua_State * L );
int LS_CANRestartDevice( lua_State * L );

int LS_CANSetCallback( lua_State * L );
int LS_CANGetMessage( lua_State * L );

int LS_CANSetFilter( lua_State * L );
int LS_CANGetFilter( lua_State * L );

int LS_CANSetGlobals( lua_State * L );
int LS_CANGetGlobals( lua_State * L );

int LS_CANWrite( lua_State * L );
int LS_CANWriteEx( lua_State * L );

int LS_CANErrorMessage( lua_State * L );
int LS_CANSetTime( lua_State * L );

int LS_CANReadDigital( lua_State * L );
int LS_CANWriteDigital( lua_State * L );

int LS_CANStartAlive( lua_State * L );
int LS_CANGetConnectState( lua_State * L );
