// ----------------------------------------------------------------------------
// Projekt       : Analytica AnaGate Lua-API
// File          : Lua-CANMessageList.hpp
// Author        : Stefan Welisch
// Copyright     : (C) 2009 by Analytica GmbH
// ----------------------------------------------------------------------------
// $Id:$
//
// $Log:$
//
// ----------------------------------------------------------------------------

#ifndef LUA_CAN_MESSAGE_LIST_HPP
#define LUA_CAN_MESSAGE_LIST_HPP

// Includes -------------------------------------------------------------------
#include <sys/types.h>
#include <vector>
#include <map>
#include "LuaCANMessage.hpp"
#include "AnaMutex.h"

// Defines --------------------------------------------------------------------

class CLuaCanMessageList
{
   public:
      typedef std::vector<CLuaCanMessage>  tvCANMessage;
      typedef std::map<int, tvCANMessage *> tMessageLists;

      /** Constructor.
          @param nHandle          Handle from connection.
          @param CLuaCanMessage   CAN-Message.
      */
      CLuaCanMessageList( void );

      /** Destructor */
      virtual ~CLuaCanMessageList( void );

      void Push( const unsigned int nHandle, CLuaCanMessage & oMessage );
      
      int Pop( const unsigned int nHandle, CLuaCanMessage * pMessage );
      
      int Size( const unsigned int nHandle );

   protected:
      CAnaMutex     m_oMutex;
      tMessageLists m_UsedLists;
   private:
};



#endif // #ifndef LUA_CAN_MESSAGE_HPP










