// ----------------------------------------------------------------------------
// Projekt       : Analytica AnaGate Lua-API
// File          : LuaCANFunctions.h
// Author        : Stefan Welisch
// Copyright     : (C) 2009 by Analytica GmbH
// ----------------------------------------------------------------------------
// $Id:$
//
// $Log:$
//
// ----------------------------------------------------------------------------

// Includes -------------------------------------------------------------------
/// Includes for Scripting
extern "C"
{
   #include "lua.h"
   #include "lauxlib.h"
   #include "lualib.h"

   extern lua_State * L;
}

#include <AnaGateDllCan.h>  // windows.h must be included before ...


namespace lua {
void RegisterCANopenFunctions( lua_State * L );
};

void WINAPI MyCallbackPDO  (unsigned char nNodeID, unsigned char nPDOTyp, unsigned char nDataLen, const char *pcData, int hHandle, long nSeconds, long nMicroseconds);
void WINAPI MyCallbackSYNC (unsigned char nReturnCode, int hHandle, long nSeconds, long nMicroseconds);
void WINAPI MyCallbackEMCY (unsigned char nNodeID, unsigned short nErrorCode, unsigned char nErrorRegister, const unsigned char *pcErrorDescription, int hHandle, long nSeconds, long nMicroseconds);
void WINAPI MyCallbackGUARD(unsigned char nNodeID, unsigned char nStatus, int hHandle, long nSeconds, long nMicroseconds);
void WINAPI MyCallbackUndefined(int nCANID, unsigned char nNodeID, unsigned char nFunctionCode, unsigned char nDataLen, const char *pcData, int hHandle, long nSeconds, long nMicroseconds);

void StandardCallbackPDO(unsigned char nNodeID, unsigned char nPDOTyp, unsigned char nDataLen, const char *pcData, int hHandle, long nSeconds, long nMicroseconds);
void StandardCallbackSYNC(unsigned char nReturnCode, int hHandle, long nSeconds, long nMicroseconds);
void StandardCallbackEMCY(unsigned char nNodeID, unsigned short nErrorCode, unsigned char nErrorRegister, const unsigned char *pcErrorDescription, int hHandle, long nSeconds, long nMicroseconds);
void StandardCallbackGUARD(unsigned char nNodeID, unsigned char nStatus, int hHandle, long nSeconds, long nMicroseconds);
void StandardCallbackUndefined(int nCANID, unsigned char nNodeID, unsigned char nFunctionCode, unsigned char nDataLen, const char *pcData, int hHandle, long nSeconds, long nMicroseconds);


/// LUA-Interface CANOpen
int LS_CANopenSetConfig( lua_State * L );
int LS_CANopenGetConfig( lua_State * L );
int LS_CANopenSetSYNCMode( lua_State * L );

int LS_CANopenSetCallbacks( lua_State * L );
int LS_CANopenGetPDO( lua_State * L );
int LS_CANopenGetSYNC( lua_State * L );
int LS_CANopenGetEMCY( lua_State * L );
int LS_CANopenGetGUARD( lua_State * L );
int LS_CANopenGetUndefined( lua_State * L );

int LS_CANopenSendNMT( lua_State * L );
int LS_CANopenSendSYNC( lua_State * L );
int LS_CANopenSendTIME( lua_State * L );
int LS_CANopenSendPDO( lua_State * L );

int LS_CANopenSendSDORead( lua_State * L );
int LS_CANopenSendSDOWrite( lua_State * L );
int LS_CANopenSendSDOReadBlock( lua_State * L );
int LS_CANopenSendSDOWriteBlock( lua_State * L );
