// ----------------------------------------------------------------------------
// Projekt       : Analytica AnaGate Lua-API
// File          : LuaFunctions.cpp
// Author        : Stefan Welisch
// Copyright     : (C) 2009 by Analytica GmbH
// ----------------------------------------------------------------------------
// $Id:$
//
// $Log:$
//
// ----------------------------------------------------------------------------

// Includes -------------------------------------------------------------------
/// Includes for Scripting
extern "C"
{
   #include "lua.h"
   #include "lauxlib.h"
   #include "lualib.h"

   extern lua_State * L;
}
#include "vector"
#include "map"
#include <iostream>
#include "string.h"
#include "stdio.h"

#ifndef WIN32
   #include <sys/time.h>
#endif

#define ERR_ALL_OK        (0)
#define ERR_SYNTAX        (-1)
#define ERR_RANGE         (-2)
#define ERR_NOT_A_NUMBER  (-3)
#define ERR_NOT_A_STRING  (-4)
#define ERR_NOT_A_BOOL    (-5)
#define ERR_NOT_A_TABLE   (-6)
#define ERR_NO_DATA       (-10)

namespace lua {

void RegisterGlobalFunctions( lua_State * L );

int CheckParameterCount( unsigned char nCount, unsigned char nMinCount, unsigned char nMaxCount );
int CheckParameter(lua_State * L, int nIndex, unsigned int & nValue);
int CheckParameter(lua_State * L, int nIndex, int & nValue);
int CheckParameter(lua_State * L, int nIndex, unsigned short & nValue);
int CheckParameter(lua_State * L, int nIndex, char & nValue);
int CheckParameter(lua_State * L, int nIndex, unsigned char & nValue);
int CheckParameter(lua_State * L, int nIndex, const char ** pValue);
int CheckParameter(lua_State * L, int nIndex, bool & bValue);

int CheckGlobal(lua_State * L, const char * pcGlobalName, bool & bValue);
int CheckGlobal(lua_State * L, const char * pcGlobalName, int & nValue);
int CheckGlobal(lua_State * L, const char * pcGlobalName, unsigned int & nValue);
int CheckGlobal(lua_State * L, const char * pcGlobalName, unsigned short & nValue);
int CheckGlobal(lua_State * L, const char * pcGlobalName, char & nValue);
int CheckGlobal(lua_State * L, const char * pcGlobalName, unsigned char & nValue);
int CheckGlobal(lua_State * L, const char * pcGlobalName, const char ** pValue);

int CheckStandardTable(lua_State * L, int nIndex, int * pnFilter, unsigned int nSize);
int CheckStandardTable(lua_State * L, int nIndex, unsigned char * pnFilter, unsigned int nSize);

};


int LS_Sleep( lua_State * L );
int LS_Lock(lua_State * L);
int LS_Unlock(lua_State * L);
int LS_GetTime(lua_State * L);
int LS_DeviceInfo(lua_State * L);
