// ----------------------------------------------------------------------------
// Projekt       : Analytica AnaGate Lua-API
// File          : LuaI2CFunctions.h
// Author        : Stefan Welisch
// Copyright     : (C) 2009 by Analytica GmbH
// ----------------------------------------------------------------------------
// $Id:$
//
// $Log:$
//
// ----------------------------------------------------------------------------

// Includes -------------------------------------------------------------------
/// Includes for Scripting
extern "C"
{
   #include "lua.h"
   #include "lauxlib.h"
   #include "lualib.h"

   extern lua_State * L;
}

#include <AnaGateDllI2C.h>  // windows.h must be included before ...


namespace lua {
void RegisterI2CFunctions( lua_State * L );
};

/// LUA-Interface
int LS_I2COpenDevice( lua_State * L );
int LS_I2CCloseDevice( lua_State * L );

int LS_I2CSetGlobals( lua_State * L );
int LS_I2CGetGlobals( lua_State * L );

int LS_I2CRead( lua_State * L );
int LS_I2CWrite( lua_State * L );

int LS_I2CReadEEProm( lua_State * L );
int LS_I2CWriteEEProm( lua_State * L );

int LS_I2CErrorMessage( lua_State * L );

int LS_I2CReadDigital( lua_State * L );
int LS_I2CWriteDigital( lua_State * L );

int LS_I2CSequence( lua_State * L );
int LS_I2CReset( lua_State * L );

int LS_I2CRAWStart( lua_State * L );
int LS_I2CRAWSend( lua_State * L );
int LS_I2CRAWGet( lua_State * L );
int LS_I2CRAWStop( lua_State * L );
